import Qt 4.7
import "imports/colibri"
import "imports/XAComponents"
import "AICalendarPickerJS.js" as XACalJS

Rectangle {
    id: aiContextPicker

    color: "transparent"

    property int pickerDirection : qtPickerDirection;
    property int pickerTopSpacer : (pickerDirection == 2) ? 16 : 0
    property int pickerBottomSpacer : (pickerDirection == 2) ? 0 : 16

    property string windowGotFocus : qtWindowGotFocus
    property string context : qtInputContext
    property string contextType : qtInputContextType

    property bool enabled: true

    function onPresetValuesCompleted() {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX VALUES LOADED.");

        context = qtInputContext
        contextType = qtInputContextType
    }

//    onFocusChanged: console.debug("AICalendarPicker: focus changed.")

    onContextTypeChanged: {
        updateCloseTabImage();
    }

    function updateCloseTabImage() {
        if (contextType == "R") {
            closeTabTopImage.source = "imports/XAComponents/pics/PreviewIconRACI_R_PopupButtonPressed16px.png";
            closeTabBottomImage.source = "imports/XAComponents/pics/PreviewIconRACI_R_PopupButtonPressed16px.png";
            typeLabel.text = "Responsible"

        } else if (contextType == "A") {
            closeTabTopImage.source = "imports/XAComponents/pics/PreviewIconRACI_A_PopupButtonPressed16px.png";
            closeTabBottomImage.source = "imports/XAComponents/pics/PreviewIconRACI_A_PopupButtonPressed16px.png";
            typeLabel.text = "Accountable"

        } else if (contextType == "C") {
            closeTabTopImage.source = "imports/XAComponents/pics/PreviewIconRACI_C_PopupButtonPressed16px.png";
            closeTabBottomImage.source = "imports/XAComponents/pics/PreviewIconRACI_C_PopupButtonPressed16px.png";
            typeLabel.text = "Consulted"

        } else if (contextType == "I") {
            closeTabTopImage.source = "imports/XAComponents/pics/PreviewIconRACI_I_PopupButtonPressed16px.png";
            closeTabBottomImage.source = "imports/XAComponents/pics/PreviewIconRACI_I_PopupButtonPressed16px.png";
            typeLabel.text = "Informed"

        } else {
            closeTabTopImage.source = "imports/XAComponents/pics/PreviewIconContextPopupButtonPressed16px.png";
            closeTabBottomImage.source = "imports/XAComponents/pics/PreviewIconContextPopupButtonPressed16px.png";
            typeLabel.text = "Context"
        }
    }

    Component.onCompleted: {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Component.onCompleted.");
        updateCloseTabImage();
    }

    function doOp(newUID) {
        QtHandler.contextAssignmentChanged(newUID);
    }

    Rectangle {
        id: closeTabTop
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 2)

        Image {
            id: closeTabTopImage
            anchors.left: parent.left
            anchors.top: parent.top
        }

        MouseArea {
            id: closeTabTopMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    Rectangle {
        id: closeTabBottom
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 1)

        Image {
            id: closeTabBottomImage
            anchors.left: parent.left
            anchors.bottom: parent.bottom
        }

        MouseArea {
            id: closeTabBottomMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    Rectangle {
        id: contentRectangle
        anchors.top: parent.top
        anchors.topMargin: pickerTopSpacer
        anchors.bottomMargin: pickerBottomSpacer
        anchors.left: parent.left
        anchors.right: parent.right

        height: xaqmladdressbookpicker.height+30

        gradient: Gradient {
            GradientStop { position: 0; color: "#222222" }
            GradientStop { position: 0.5; color: "#3f3b3c" }
            GradientStop { position: 1; color: "#222222" }
        }

        radius: 0
        smooth: true

        Text {
            id: typeLabel
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.topMargin: 4
            height: 18

            color: "white"
            clip: true
            smooth: true

            font.family: "Arial"
            font.bold: true
            font.pixelSize: 11
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
        }

        XAHDivisionLine {
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.topMargin: 22
        }

        XAQMLAddressBookPicker {
            id: xaqmladdressbookpicker
            anchors.top: parent.top
            anchors.topMargin: 22
            width: 250
            height: 340

            enabled: true

            onEntrySelectionChanged: doOp(uid)
        }

    }

}


